<?php
/*
 * ----------------------------------------------------------------------------
 * Post-Email.php                                                    05/13/2004
 * This script displays the new message/reply form to the user.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2004 Steve Winn. All Rights Reserved.
 *
 * The source code contains a fair amount of comments, which may aid anyone
 * attempting to follow the program or to modify it.
 *
 * For licensing and copyright information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

session_cache_limiter('private, must-revalidate');  // Useful if a user hits the back button.

require_once('include_dir.php');                    // Get include directory.
require_once($includeDir . 'va-functions.inc.php'); // A VADV-PHP script.
require_once($includeDir . 'va-database.inc.php');  // Include database functions.
require_once($includeDir . 'va-main.inc.php');      // Include main configuration.
require_once($includeDir . 'va-networks.inc.php');  // Include network information.
require_once('layout_email.inc.php');               // Webpage header and footer.

if ((!isset($_POST['referer'])) && (!isset($_GET['referer']))) {
    die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
}
if (isset($_GET['referer'])) {
    $_POST['referer'] = urldecode($_GET['referer']);
}

// Check for cancel button.
if ((isset($_POST['submit'])) && ($_POST['submit'] == 'Cancel')) {
    RedirectUser($_POST['referer']);
}

$dbInfo = SetEmailInfo($USER['userno']);
$VA_NETWORKS = GetNetworkInfo();

// Check user's write security level.
if ((($USER['userno'] == 0) ||
     ($USER['userno'] == $CONFIG['guestacct'])) ||
    (($USER['userno'] != 0) &&
     ($USER['securitylevel'] < $dbInfo['minwritesl']))) {
    die('<br /><h4>You do not have access to email others. Please press the BACK button on your browser.</h4>');
}

if ((isset($_POST['reply'])) && ($_POST['reply'] != 0)) {   // Set the passed variables.
    $reply = intval($_POST['reply']);
    $u = 0;
    $msgInfo = GetMessageInfo($dbInfo, $reply);
} else {
    $reply = 0;
    $u = 0;
    if ((isset($_GET['u'])) && (intval($_GET['u']) > 0)) {
        $u = intval($_GET['u']);
    } else if ((isset($_POST['u'])) && (intval($_POST['u']) > 0)) {
        $u = intval($_POST['u']);
    }
}

// Check to see if the message was already created and needs to be processed.
if ((isset($_POST['msgflag'])) && ($_POST['msgflag'] == 1)) {
    if (isset($_POST['touser'])) {
        $toUser = htmlspecialchars($_POST['touser']);
        if (isset($_POST['tonetid'])) {
            $toNetId = intval($_POST['tonetid']);
            if ($_POST['tonetid'] == 0) {   // Determine if a local or network email.
                $toUserString = $toUser . '@0*' . $toNetId;
            } else {
                $atpos = strpos($toUser, '@');
                if ($atpos === FALSE) die('<br /><h4>Invalid recipient address. Please enter in the format of user@networkaddress. Please press the BACK button on your browser.</h4>');
                $toUserString = $toUser . '*' . $toNetId;
            }
        }
    } else {
        die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
    }
    
    if (isset($_POST['subject'])) {
        $msgSubject = $_POST['subject'];
    } else {
        die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
    }

    if (isset($_POST['msgbody'])) {
        $msgBody = $_POST['msgbody'];
    } else {
        die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
    }

    $attFilename = '';
    if ((isset($_FILES['attfile'])) && ($_FILES['attfile']['size'] > 0)) {
        // Validate user access for upload files.
        if (($USER['securitylevel'] < $VA_MAIN['emlotherfile']) ||
            ((trim(ini_get('file_uploads')) == '')) ||
             (!is_dir(ini_get('upload_tmp_dir')))) {
            die('<br /><h4>There was an error with your attached file. Please press the BACK button on your browser.</h4>');
            // Erase the uploaded file.
            if (is_uploaded_file($_FILES['attfile']['tmp_name'])) {
                unlink($_FILES['attfile']['tmp_name']);
            }
        }

        // Access granted, continue...
        if ($_FILES['attfile']['error'] == 'UPLOAD_ERR_OK') {
            if (is_uploaded_file($_FILES['attfile']['tmp_name'])) {
                $userDirectory = $VA_SYSPATHS['sysop'] . '/' . $USER['userno'];
                $filename      = ConvertLongFilename($_FILES['attfile']['name'], $userDirectory);
                $attFilename   = str_replace('/', "\\", $userDirectory . '/' . $filename);
                if (!is_dir($userDirectory)) {
                    mkdir($userDirectory);
                }
                move_uploaded_file($_FILES['attfile']['tmp_name'], $attFilename);

                // Add any information to the message itself.
                $msgBody = rtrim($msgBody) . "\r\n\r\n\r\n--------------";
                $msgBody = $msgBody . "\r\nAttached file: " . $filename;
                if ($filename != $_FILES['attfile']['name']) {
                    $msgBody = $msgBody . "\r\nOriginal filename: " . $_FILES['attfile']['name'] . "\r\nThe filename was changed for compatibility reasons.";
                }
            }
        } else {
            switch ($_FILES['attfile']['error']) {
                case 'UPLOAD_ERR_FORM_SIZE':
                    unlink($_FILES['attfile']['tmp_name']);
                    die('<br /><h4>Attached file is too big (>5MB). Please press the BACK button on your browser.</h4>');
                    break;
                case 'UPLOAD_ERR_PARTIAL':
                    unlink($_FILES['attfile']['tmp_name']);
                    die('<br /><h4>Attached file upload was interrupted. Please press the BACK button on your browser.</h4>');
                    break;
                case 'UPLOAD_ERR_NO_FILE':
                    die('<br /><h4>Invalid attachment. Please press the BACK button on your browser.</h4>');
                    break;
                default:
                    die('<br /><h4>An error with the file attachment occurred. Please press the BACK button on your browser.</h4>');
                    break;
            }
        }
    }

    $pos = strrpos($_POST['referer'], '/');
    $url = substr($_POST['referer'], 0, $pos);

    $log = 'E-Mail Sent     "' . $USER['handle'] . '" --> "' . $toUserString . '" - ' . $msgSubject;
    WriteLog('vadv-php.log', $log);         // Log the email.
    WriteEmail($USER['userno'], $toUserString, $msgSubject, $msgBody, $reply, $attFilename);

    if ($reply > 0) {
        // Return to message.
        RedirectUser($url . '/email-viewmsg.php?m=' . $reply);
    } else {
        // Return to message listing.
        if ($u > 0) {
            RedirectUser($_POST['referer']);
        } else {
            RedirectUser($url . '/email-dispmsg.php');
        }
    }
}

EmailHeader();
?>
<script language="javaScript">
<!--
function validate(form) {
    if ((form.touser.value.length == 0) ||
        (form.subject.value.length == 0)) {
        alert("Please enter a recipient address, and a subject.");
        <?php if ($reply == 0) { ?>
        form.touser.focus();
        <?php } else { ?>
        form.subject.focus();
        <?php } ?>
        return false;
    }
}
//-->
</script>
<form name="postmsg" method="POST" action="post-email.php" enctype="multipart/form-data" onsubmit="return validate(postmsg)">
    <input type="hidden" name="referer" value="<?php print $_POST['referer']; ?>">
    <input type="hidden" name="reply" value="<?php print $reply; ?>">
    <input type="hidden" name="u" value="<?php print $u; ?>">
    <?php if (isset($reply) && ($reply > 0)) { ?>
        <input type="hidden" name="touser" value="<?php print $msgInfo['fromhandle'] . '@' . $msgInfo['fromnetnode']; ?>">
        <input type="hidden" name="tonetid" value="<?php print $msgInfo['fromnetid']; ?>">
    <?php } ?>
    <input type="hidden" name="msgflag" value="1">
    <div align="center">
        <center>
        <table border="1" cellpadding="2" cellspacing="0" style="border-collapse: collapse" width="750" bordercolor="#666666" bgcolor="#E2E2E2">
            <tr>
                <td height="25" colspan="2" bgcolor="#416DBF" align="left">
                    <p class="msgTitle">&nbsp;&nbsp;<?php print $dbInfo['desc']; ?> - New Message</p></td>
            </tr>
            <tr>
                <td height="15" colspan="2" bgcolor="#000080" align="left">
                    <p class="msgHeader">&nbsp;</p></td>
            </tr>
            <tr>
                <td align="center" valign="top">
                    <table border="0" cellspacing="1" style="border-collapse: collapse" bordercolor="#111111" width="639">
                        <tr>
                            <td width="90" height="25" valign="top">
                                <p class="boldBody">To:</p></td>
                            <td height="25">
                                <p><?php
                                   if ($reply > 0) {
                                       print '<span class="boldBody">' . $msgInfo['fromhandle'] . ' </span><span class="body">@' . $msgInfo['fromnetnode'] . '  ' . $VA_NETWORKS[$msgInfo['fromnetid']]['desc'] . '</span>';
                                   } else {
                                   ?>
                                    <input name="touser" type="text" size="40" maxlength="40" <?php
                                                                                              if ($u > 0) {
                                                                                                  print 'value="' . $u . '"';
                                                                                              }
                                                                                              ?>>
                                    <select name="tonetid" size="1">
                                        <option selected value="0">Local</option>
                                        <?php
                                            $pos = 0;
                                            $cnt = 0;
                                            $net = array();
                                            for ($x = 1; $pos < $VA_NETWORKS[0]; $x++) {
                                                if (isset($VA_NETWORKS[$x])) {
                                                    if (($VA_NETWORKS[$x]['nettype'] != 2) &&   // If not a VLive network
                                                         ($VA_NETWORKS[$x]['nettype'] != 5)) {  // If not a QWK network
                                                        if (($USER['securitylevel'] >= 255) ||
                                                            ($VA_NETWORKS[$x]['accflag'] == '') ||                                  // If a access flag is set..
                                                            (strpos($USER['flags'], $VA_NETWORKS[$x]['accflag']) !== FALSE)) {      // If the user has the flag
                                                            switch ($VA_NETWORKS[$x]['nettype']) {
                                                                case 1:
                                                                    $type = 'VirtualNET';
                                                                    break;
                                                                case 3:
                                                                    $type = 'Internet';
                                                                    break;
                                                                case 4:
                                                                    $type = 'FIDOnet';
                                                                    break;
                                                                case 9:
                                                                    $type = 'WWIVnet';
                                                                    break;
                                                                default:
                                                                    $type = 'Unknown';
                                                                    break;
                                                            }
                                                            $net[$cnt]['netno']    = $VA_NETWORKS[$x]['netno'];
                                                            $net[$cnt]['desc']     = $VA_NETWORKS[$x]['desc'];
                                                            $net[$cnt]['sortdesc'] = strtolower($VA_NETWORKS[$x]['desc']);
                                                            $net[$cnt]['type']     = $type;
                                                            $cnt++;
                                                        }
                                                    }
                                                    $pos++;
                                                }
                                            }
                                            // Organize the array alphabetically by description.
                                            $sortarr = array();
                                            foreach ($net as $row) {
                                                $sortarr[] = $row['sortdesc'];
                                            }
                                            array_multisort($sortarr, $net);

                                            // Display the listing.
                                            for ($x = 0; $x < count($net); $x++) {
                                                print '<option value="' . $net[$x]['netno'] . '">' . $net[$x]['desc'] . ' (' . $net[$x]['type'] . ")</option>\n";
                                            }
                                        ?>
                                    </select>
                                    <?php } ?></p>
                            </td>
                        </tr>
                        <tr>
                            <td width="90" height="25" valign="top">
                                <p class="boldBody">Subject:</p></td>
                            <td height="25">
                                <input name="subject" type="text" size="64" maxlength="64" value="<?php if ($reply > 0) print $msgInfo['subject']; ?>"></td>
                        </tr>
                        <?php
                            if (($USER['securitylevel'] >= $VA_MAIN['emlotherfile']) &&
                                ((trim(ini_get('file_uploads')) != '')) &&
                                 (is_dir(ini_get('upload_tmp_dir')))) {
                        ?>
                        <tr>
                            <td width="90" height="25" valign="top">
                                <p class="body">Att File:</p></td>
                            <td height="25">
                                <?php
                                $maxsize = ini_get('upload_max_filesize');
                                $megpos  = strpos(strtoupper($maxsize), 'M');
                                if ($megpos !== FALSE) {
                                    $maxsize = substr($maxsize, 0, $megpos);
                                    $maxsize = 1024 * 1024 * $maxsize;
                                }
                                ?>
                                <input type="hidden" name="MAX_FILE_SIZE" value="<?php print $maxsize; ?>">
                                <input name="attfile" type="file" size="64"></td>
                        </tr>
                        <?php
                            }
                        ?>
                        <tr>
                            <td width="90" height="25" valign="top">
                                <p class="boldBody">Message:</p></td>
                            <td>
                                <textarea name="msgbody" rows="15" cols="80" wrap="soft"><?php
                                                                                         if ($reply > 0) {
                                                                                             print 'Re: ' . $msgInfo['subject'] . QuoteMessage(StripRouting(GetMessage($dbInfo, $reply, 2))) . "\r\n";
                                                                                         }
                                                                                         ?></textarea>
                                <table border="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="100%" cellpadding="2">
                                    <tr>
                                        <td align="right" width="340">
                                            <input type="submit" value="Submit" name="submit">
                                            <input type="reset" value="Reset" name="reset">
                                        </td>
                                        </form>
                                        <form name="cancelPost" method="POST" action="post-email.php">
                                            <td align="left">
                                                <input type="hidden" name="referer" value="<?php print $_POST['referer']; ?>">
                                                <input type="submit" value="Cancel" name="submit">
                                            </td>
                                        </form>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td colspan="2" bgcolor="#416DBF" align="left">&nbsp;</td>
            </tr>
        </table>
        </center>
    </div>
<?php

EmailFooter();

?>
