<?php
/*
 * ----------------------------------------------------------------------------
 * Post-Message.php                                                  05/13/2004
 * This script displays the new message/reply form to the user.
 * ----------------------------------------------------------------------------
 * Copyright (C) 2002-2004 Steve Winn. All Rights Reserved.
 *
 * The source code contains a fair amount of comments, which may aid anyone
 * attempting to follow the program or to modify it.
 *
 * For licensing and copyright information, view LICENSE.TXT.
 * ----------------------------------------------------------------------------
 */

session_cache_limiter('private, must-revalidate');  // Useful if a user hits the back button.

require_once('include_dir.php');                    // Get include directory.
require_once($includeDir . 'va-functions.inc.php'); // A VADV-PHP script.
require_once($includeDir . 'va-database.inc.php');  // Include database functions.
require_once('layout_forum.inc.php');               // Webpage header and footer.

if (!isset($_POST['referer'])) {
    die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
}

$error = 0;
if (isset($_POST['t'])) {                   // Set the passed variables.
    $t = intval($_POST['t']);
} else {
    $error = 1;
}

if (isset($_POST['d'])) {                   // Set the passed variables.
    $d = intval($_POST['d']);
} else {
    $error = 1;
}

// Check for cancel button.
if ((isset($_POST['submit'])) && ($_POST['submit'] == 'Cancel')) {
    RedirectUser($_POST['referer'] . '?t=' . $t . '&d=' . $d);
}

$dbInfo = GetDbInfo($t, $d);

// Check user's write security level.
if ((($USER['userno'] == 0) ||
     ($USER['userno'] == $CONFIG['guestacct'])) ||
    (($USER['userno'] != 0) &&
     ($USER['userno'] != $CONFIG['guestacct']) &&
     ($USER['securitylevel'] < $dbInfo['minwritesl']))) {
    die('<br /><h4>You do not have access to post in this area. Please press the BACK button on your browser.</h4>');
}

if ((isset($_POST['reply'])) && ($_POST['reply'] != 0)) {   // Set the passed variables.
    $reply = intval($_POST['reply']);
    $msgInfo = GetMessageInfo($dbInfo, $reply);
} else {
    $reply = 0;
}

if ($error == 1) {
    die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
}

if ((isset($_POST['msgflag'])) && ($_POST['msgflag'] == 1)) {
    if (isset($_POST['subject'])) {
        $msgSubject = $_POST['subject'];
    } else {
        die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
    }
    
    if (isset($_POST['msgbody'])) {
        $msgBody = $_POST['msgbody'];
    } else {
        die('<br /><h4>Invalid message parameters. Please press the BACK button on your browser.</h4>');
    }

    $log = 'Message Sent    "' . $USER['handle'] . '" --> "' . $dbInfo['desc'] . '" - ' . $msgSubject;
    WriteLog('vadv-php.log', $log);         // Log the email.
    WriteMessage($dbInfo, $USER['userno'], $msgSubject, $msgBody, $reply);

    // Return to message listing.
    $pos = strrpos($_POST['referer'], '/');
    $url = substr($_POST['referer'], 0, $pos);
    RedirectUser($url . '/forum-dispmsg.php?t=' . $t . '&d=' . $d);
}

if (trim($dbInfo['desc']) != '') {
    $dbDesc = htmlspecialchars($dbInfo['desc']);
} else {
    $dbDesc = '(No Description)';
}
        
ForumHeader();
?>
<script language="javaScript">
<!--
function validate(form) {
    if ((form.subject.value.length == 0) ||
        (form.msgbody.value.length == 0)) {
        alert("Please enter a subject and a message.");
        form.subject.focus();
        return false;
    }
}
//-->
</script>
<form name="postmsg" method="POST" action="post-message.php" onsubmit="return validate(postmsg)">
    <input type="hidden" name="referer" value="<?php print $_POST['referer']; ?>">
    <input type="hidden" name="t" value="<?php print $t; ?>">
    <input type="hidden" name="d" value="<?php print $d; ?>">
    <input type="hidden" name="reply" value="<?php print $reply; ?>">
    <input type="hidden" name="msgflag" value="1">
    <div align="center">
        <center>
        <table border="1" cellpadding="2" cellspacing="0" style="border-collapse: collapse" width="750" bordercolor="#666666" bgcolor="#E2E2E2">
            <tr>
                <td height="25" colspan="2" bgcolor="#416DBF" align="left">
                    <p class="msgTitle">&nbsp;&nbsp;<?php print $dbDesc; ?> - New Message</p></td>
            </tr>
            <tr>
                <td height="15" colspan="2" bgcolor="#000080" align="left">
                    <p class="msgHeader">&nbsp;</p></td>
            </tr>
            <tr>
                <td align="center" valign="top">
                    <table border="0" cellspacing="1" style="border-collapse: collapse" bordercolor="#111111" width="639">
                        <tr>
                            <td width="90" height="25" valign="top">
                                <p class="boldBody">To:</p></td>
                            <td height="25">
                                <p class="boldBody"><?php
                                                    if ($reply > 0) {
                                                        print $msgInfo['fromhandle'];
                                                    } else {
                                                        print 'All';
                                                    }
                                                    ?></p></td>
                        </tr>
                        <tr>
                            <td width="90" height="25" valign="top">
                                <p class="boldBody">Subject:</p></td>
                            <td height="25">
                                <input name="subject" type="text" size="64" maxlength="64" value="<?php if ($reply > 0) print $msgInfo['subject']; ?>"></td>
                        </tr>
                        <tr>
                            <td width="90" height="25" valign="top">
                                <p class="boldBody">Message:</p></td>
                            <td>
                                <textarea name="msgbody" rows="15" cols="80" wrap="soft"><?php
                                                                                         if ($reply > 0) {
                                                                                             print 'Re: ' . $msgInfo['subject'] . QuoteMessage(StripRouting(GetMessage($dbInfo, $reply, 2))) . "\r\n";
                                                                                         }
                                                                                         ?></textarea>
                                <table border="0" cellspacing="0" style="border-collapse: collapse" bordercolor="#111111" width="100%" cellpadding="2">
                                    <tr>
                                        <td align="right" width="340">
                                            <input type="submit" value="Submit" name="submit">
                                            <input type="reset" value="Reset" name="reset">
                                        </td>
                                        </form>
                                        <form name="cancelPost" method="POST" action="post-email.php">
                                            <td align="left">
                                                <input type="hidden" name="referer" value="<?php print $_POST['referer']; ?>">
                                                <input type="submit" value="Cancel" name="submit">
                                            </td>
                                        </form>
                                    </tr>
                                </table>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
            <tr>
                <td colspan="2" bgcolor="#416DBF" align="left">&nbsp;</td>
            </tr>
        </table>
        </center>
    </div>
</form>
<?php

ForumFooter();

?>
